////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
*
* FILE NAME:		main.c
*
* DESCRIPTION:		RT-edge C2C(R)
*
*
\*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rt.h>
#include "edgeCode.h"		// RT-edge T[rXʒ`/֐wb_ǉ

#define EWRAP_RSL_INIT		"HiInit"
#define EWRAP_RSL_OPEN		"HiOpen"
#define EWRAP_RSL_CLOSE		"HiClose"
#define EWRAP_RSL_READ		"HiRead"
#define EWRAP_RSL_WRITE		"HiWrite"
#define EWRAP_RSL_RECON		"HiReConnect"
#define EWRAP_RSL_CONCHK	"HiConnectChk"

/*****************************************************************************
* FUNCTION:			fnGetCommandLine
* DESCRIPTION:		R}h擾
******************************************************************************/
int fnGetCommandLine(int argc, char* argv[])
{
	int i;
	//ꍇ̂ݏs
	if (argc < 3)
	{
		printf("wrong number of arguments (given 0, expected 2+)\n");
		return -2;
	}
	for(i=1; i<argc; i++){
		if (_stricmp(argv[i], "-rsl") == 0)//-rsl ̎w肪ꍇA̕l
		{
			i++;
			if (argv[i] == NULL) break;//ꍇI
			if (strlen(argv[i]) < 256)	//256obt@mۂĂ邽߂ȏNGƂ
			{
				memcpy_s(MyFwDesc.chRSL, sizeof(MyFwDesc.chRSL), argv[i], strlen(argv[i]));	// RSLpXۊ
				return 0;//I
			}
			else
			{
				printf("Size Error Proccess Argument = RSL Path=[%s]\n", argv[i]);
				return -3;
			}
			break;
		}
	}
	printf("wrong number of arguments (given 0, expected 1+)\n");
	return -1;
}
/*****************************************************************************
* FUNCTION:			fnLoadLibrary
* DESCRIPTION:		RSL[hA֐AhX擾
******************************************************************************/
int fnLoadLibrary()
{
	//pXꍇ̓G[I
	if (strlen(MyFwDesc.chRSL) == 0)
	{
		printf("RSL path not specified.\n");
		return -1;
	}
	//Cũ[h
	MyFwDesc.hRslLib = LoadRtLibrary(MyFwDesc.chRSL);
	if (MyFwDesc.hRslLib == NULL_RTHANDLE) {
		// Cu[hs
		printf("RSL Load Fail[%s]\n", MyFwDesc.chRSL);	// O
		return -2;
	}

	//֐AhX̎擾 HiInit
	MyFwDesc.RSLHiInit = GetRtProcAddress(MyFwDesc.hRslLib, EWRAP_RSL_INIT);
	if (MyFwDesc.RSLHiInit == NULL)
	{
		// INIT֐̃[hs
		printf("RSL HiInit Function Load Fial[%s]\n", MyFwDesc.chRSL);	// O
		return -3;
	}
	//֐AhX̎擾 HiOpen
	MyFwDesc.RSLHiOpen = GetRtProcAddress(MyFwDesc.hRslLib, EWRAP_RSL_OPEN);
	if (MyFwDesc.RSLHiOpen == NULL)
	{
		// OPEN֐̃[hs
		printf("RSL HiOpen Function Load Fial[%s]\n", MyFwDesc.chRSL);	// O
		return -4;
	}
	//֐AhX̎擾 HiClose
	MyFwDesc.RSLHiClose = GetRtProcAddress(MyFwDesc.hRslLib, EWRAP_RSL_CLOSE);
	if (MyFwDesc.RSLHiClose == NULL)
	{
		// CLOSE֐̃[hs
		printf("RSL HiClose Function Load Fial[%s]\n", MyFwDesc.chRSL);	// O
		return -5;
	}
	//֐AhX̎擾 HiRead
	MyFwDesc.RSLHiRead = GetRtProcAddress(MyFwDesc.hRslLib, EWRAP_RSL_READ);
	if (MyFwDesc.RSLHiRead == NULL)
	{
		// READ֐̃[hs
		printf("RSL HiRead Function Load Fial[%s]\n", MyFwDesc.chRSL);	// O
		return -6;
	}
	//֐AhX̎擾 HiWrite
	MyFwDesc.RSLHiWrite = GetRtProcAddress(MyFwDesc.hRslLib, EWRAP_RSL_WRITE);
	if (MyFwDesc.RSLHiWrite == NULL)
	{
		// READ֐̃[hs
		printf("RSL HiWrite Function Load Fial[%s]\n", MyFwDesc.chRSL);	// O
		return -6;
	}
	//֐AhX̎擾 HiReConnect
	MyFwDesc.RSLHiReConnect = GetRtProcAddress(MyFwDesc.hRslLib, EWRAP_RSL_RECON); //Ăǂ@Ȃ
	//֐AhX̎擾 HiConnectChk
	MyFwDesc.RSLHiConnectChk = GetRtProcAddress(MyFwDesc.hRslLib, EWRAP_RSL_CONCHK); //Ăǂ@Ȃ
	return 0;
}
/*****************************************************************************
*
* FUNCTION:			main
*
* DESCRIPTION:		C
*
*
\*****************************************************************************/
int			main(int argc, char* argv[])
{
	EVENTINFO		ei;						// INtimeVXeCxg̏̈ג`
	int ret = 0;

	memset(&MyState, 0, sizeof(MyState));	// Xe[^Xp\̏
	memset(&MyFwDesc, 0, sizeof(EgFWdesc));	// \̏

	ret = fnGetCommandLine(argc, argv);		// R}hC`FbN
	if (ret != 0) return ret; //bZ[W͒ŏo

	ret = fnLoadLibrary();					// Cũ[h
	if (ret != 0) return ret;				// bZ[W͒ŏo

	InitService(&MyState);					// T[rX̏ ֐Ăяo

	SynchronizeRtLoader();					// T[rX̒ʒm

	while (1)								// Cxgҋ@
	{
		RtNotifyEvent(ALL_NOTIFICATIONS, WAIT_FOREVER, &ei);	// INtimeVXeCxg̏
		switch (ei.dwNotifyType)
		{
		case TERMINATE:						// Intex̍폜w
			KillService(&MyState);			// T[rX폜ivZX~j
			EgFinalize();					// EdgeVXe(K{ Edget[[N㏈)
			exit(0);						// T[rXvZX폜
			break;
		case KERNEL_SHUTDOWN_PENDING:		// INtimeJ[l̒~w
			KillService(&MyState);			// T[rX폜ivZX~j
			EgFinalize();					// EdgeVXe(K{ Edget[[N㏈)
			exit(0);						// T[rXvZX폜
			break;
		case NT_BLUESCREEN:					// WindowsNbV
			break;
		}
	}
	return 0;
}

