////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
// eWrapECAT.c
// DLLAvP[ṼGg|Cg`܂

#include <rt.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../EgC2CR/edgeCode.h"
#include "eWrapEIPC.h"
#include "../EgCommon/edgeCommon.h"
//
//{RSLŎgp^O`
//
char PROP_MYSERV_RWAPI_TIMEOUT[EG_MAX_TAGNAME + 1] = { 0 };	// Read/WritepAPI Ăяõ^CAEg
char PROP_MYSERV_STATEAPI_TIMEOUT[EG_MAX_TAGNAME + 1] = { 0 };	// StatepAPI Ăяõ^CAEg
char PROP_MYSERV_CHANNELNO[EG_MAX_TAGNAME + 1] = { 0 };		// `lԍ
//----------------------------------------------------------------------------
// macro : Get function pointer
//----------------------------------------------------------------------------
#define E$(PMSG, ...)		printf("E$EWRAPEIPC.C""[%05d] "PMSG, __LINE__, __VA_ARGS__);
#define LOAD_API(err_code, handle, pfn, name)                       \
	*((LPPROC*)&(pfn)) = GetRtProcAddress(handle, name);            \
	if( (pfn) == NULL ) {                                           \
		E$("GetRtProcAddress( %s ) failed. Status[%08Xh]\n", name, (err_code | (WORD)GetLastRtError())); \
	}	
#define _MAKEINTRESOURCE(i) ((LPSTR)((ULONG_PTR)((WORD)(i))))

//----------------------------------------------------------------------------
// [Jϐ`
//----------------------------------------------------------------------------
static RTHANDLE		s_hHiAPILib = NULL_RTHANDLE;
//----------------------------------------------------------------------------
// hiecatapi ذ߲Ċi[`
//----------------------------------------------------------------------------
static DWORD(*__HiInit)(char *szIFName, char *Config, IFHANDLE *hIF, DWORD dwTimeout) = NULL;
static DWORD(*__HiOpen)(IFHANDLE hIF, char *Target, RSIHANDLE *hRsi, DWORD dwTimeout);
static DWORD(*__HiClose)(RSIHANDLE hRsi);
static DWORD(*__HiRead)(RSIHANDLE hRsi, DWORD dwAddr, void *Buf, DWORD dwSize, DWORD dwBufSize, DWORD dwTimeout);
static DWORD(*__HiWrite)(RSIHANDLE hRsi, DWORD dwAddr, void *Buf, DWORD dwSize, DWORD dwTimeout);

/*****************************************************************************
* FUNCTION:			fnServiceTagNameCreate
* DESCRIPTION:		^O/J^O𐶐
\*****************************************************************************/
void fnServiceTagNameCreate()
{
	// T[rXvpeB^O
	sprintf(PROP_MYSERV_RWAPI_TIMEOUT, "SERVICE.%s.rwapi_timeout", ServiceRealName);		// Read/WritepAPI Ăяõ^CAEg
	sprintf(PROP_MYSERV_STATEAPI_TIMEOUT, "SERVICE.%s.stateapi_timeout", ServiceRealName);	// StatepAPI Ăяõ^CAEg
	sprintf(PROP_MYSERV_CHANNELNO, "SERVICE.%s.channelNo", ServiceRealName);				// `lԍ
}

/*****************************************************************************
* FUNCTION:			fnSetConfig
* DESCRIPTION:		ݒ蕶쐬
\*****************************************************************************/
void fnSetConfig(char** ppInitConf)
{
	int32_t result;
	DWORD dwValue = 0;
	//Tag̓Ǎ

	// Read/WritepAPI Ăяõ^CAEg rwapi_timeout
	result = EgTagRead(PROP_MYSERV_RWAPI_TIMEOUT, &dwValue, sizeof(DWORD));
	if (result == 0)
		fnStringSet_Uint(ppInitConf, "rwapi_timeout=", (uint)dwValue);

	dwValue = 0;
	//StatepAPI Ăяõ^CAEg
	result = EgTagRead(PROP_MYSERV_STATEAPI_TIMEOUT, &dwValue, sizeof(DWORD));
	if (result == 0)
		fnStringSet_Uint(ppInitConf, "stateapi_timeout=", (uint)dwValue);
}
/*****************************************************************************
* FUNCTION:			fnSetTarget
* DESCRIPTION:		openp Target쐬
\*****************************************************************************/
void fnSetTarget(char** ppTarget)
{
	int32_t result;
	WORD woValue = 0;
	//Tag̓Ǎ

	// Read/WritepAPI Ăяõ^CAEg rwapi_timeout
	result = EgTagRead(PROP_MYSERV_CHANNELNO, &woValue, sizeof(WORD));
	if (result == 0)
		fnStringSet_Uint(ppTarget, "ch", (uint)woValue);
}
/*****************************************************************************
* FUNCTION:			fnRetValue
* DESCRIPTION:		APĨXe[^Xɖ߂l
\*****************************************************************************/
DWORD fnRetValue(DWORD dwAPIStatus)
{
	if (dwAPIStatus == 0) //0͐
		return CB_STS_OK;
	if (dwAPIStatus >= 0x20000000)
		return CB_STS_FATALERR;	//s\/vIȃG[

	return CB_STS_ERROR;//ȊO͒ʏG[\G[(~߂Ȃ)
}
/*****************************************************************************
* FUNCTION:     HiInit
*
* DESCRIPTION:
*  hCo
\*****************************************************************************/
DWORD HiInit(char* szIFName, IFHANDLE* hIF, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	char* pInitConf = NULL;

	fnServiceTagNameCreate();								//Ŏgp^O쐬
	if (NULL != __HiInit)	//֐ꍇs
	{
		//config̐ݒ tag擾
		fnSetConfig(&pInitConf);

		// InitsŐݒt@Cς邽߂ŏo bΉ
		if(pInitConf != NULL)
			Log$(ServiceRealName, EG_LOG_DBG, "HiInit Config[%s]", pInitConf);

		//	inits	
		*dwAPIStatus = __HiInit(szIFName, pInitConf, hIF, dwTimeout);	//֐Ăяo
		// T[rXNԂ̕ωOɏo͂
		if (pInitConf != NULL)
		{
			Log$(ServiceRealName, EG_LOG_DBG, "HiInit Status[%08xH]", *dwAPIStatus);
			free(pInitConf);
		}
		else
			Log$(ServiceRealName, EG_LOG_DBG, "HiInit Config = NULL, Status[%xH]", *dwAPIStatus);

		return fnRetValue(*dwAPIStatus);	//߂lϊ
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiOpen
*
* DESCRIPTION:
*  hCoI[v
\*****************************************************************************/
DWORD HiOpen(IFHANDLE hIF, RSIHANDLE* hRsi, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	char* pTarget = NULL;
	if(NULL != __HiOpen)	//֐ꍇs
	{
		//target̐ݒ tag擾
		fnSetTarget(&pTarget);

		// InitsŐݒt@Cς邽߂ŏo bΉ
		if (pTarget != NULL)
			Log$(ServiceRealName, EG_LOG_DBG, "HiOpen Target[%s]", pTarget);

		// TargetNULL
		*dwAPIStatus = __HiOpen(hIF, pTarget, hRsi, dwTimeout);	//֐Ăяo
		if (pTarget != NULL)
		{
			Log$(ServiceRealName, EG_LOG_DBG, "HiOpen Target[%s], Status[%08xH]", pTarget, *dwAPIStatus);
			free(pTarget);
		}
		else
			Log$(ServiceRealName, EG_LOG_DBG, "HiOpen Config = NULL, Status[%xH]", *dwAPIStatus);

		return fnRetValue(*dwAPIStatus);		//߂lϊ
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiClose
*
* DESCRIPTION:
*  hCoN[Y
\*****************************************************************************/
DWORD HiClose(RSIHANDLE hRsi, DWORD* dwAPIStatus)
{
	if (NULL != __HiClose)	//֐ꍇs
	{
		*dwAPIStatus = __HiClose(hRsi);	//֐Ăяo
		return fnRetValue(*dwAPIStatus);	//߂lϊ
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiRead
*
* DESCRIPTION:
*  hCoǍ
\*****************************************************************************/
DWORD HiRead(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD readsize, BYTE *pData, DWORD buffersize, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != __HiRead)	//֐ꍇs
	{
		*dwAPIStatus = __HiRead(hRsi, address, pData, readsize, buffersize, dwTimeout);	//֐Ăяo
		return fnRetValue(*dwAPIStatus);//߂lϊ
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiWrite
*
* DESCRIPTION:
*  hCoݏ
\*****************************************************************************/
DWORD HiWrite(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD writesize, BYTE *pData, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != __HiWrite)	//֐ꍇs
	{
		*dwAPIStatus = __HiWrite(hRsi, address, pData, writesize, dwTimeout);	//֐Ăяo
		return fnRetValue(*dwAPIStatus);//߂lϊ
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiReConnect
*
* DESCRIPTION:
*  Đڑp֐
\*****************************************************************************/
DWORD HiReConnect(void* ptr, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	DWORD ret = CB_STS_OK;
	EgFWdesc* egdec = (EgFWdesc*)ptr;
	if (egdec != NULL)
	{
		if (egdec->hRsi != NULL_RTHANDLE)
			ret = HiClose(egdec->hRsi, dwAPIStatus);

		if (egdec->hIF != NULL_RTHANDLE)
			return HiOpen(egdec->hIF, &egdec->hRsi, dwTimeout, dwAPIStatus);
	}
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiConnectChk
*
* DESCRIPTION:
*  ڑ`FbNp֐
\*****************************************************************************/
BOOL HiConnectChk(void* ptr, DWORD dwTimeout, DWORD* dwErrorStatus)
{
	// FLNET͖TRUEԂ
	return TRUE;
}
//----------------------------------------------------------------------------
// nCx API̴ذ߲ēǂݍݏ
//----------------------------------------------------------------------------
bool	fnLoadHiApiEntry()
{
	s_hHiAPILib = LoadRtLibrary(HIAPI_RSL_NAME);	// RSL̓I۰ގ
	if (NULL_RTHANDLE != s_hHiAPILib) {			// RSL̓I۰ސ?
	
		//֐Ŋ֐|C^擾
		LOAD_API(0x80010000, s_hHiAPILib, __HiInit, "Init");
		LOAD_API(0x80020000, s_hHiAPILib, __HiOpen, "Open");
		LOAD_API(0x80030000, s_hHiAPILib, __HiClose, "Close");
		LOAD_API(0x80040000, s_hHiAPILib, __HiRead, "Read");
		LOAD_API(0x80050000, s_hHiAPILib, __HiWrite, "Write");
		
		return true;
	}
	printf("Load HiLevelApi RSL Frailed(%s\n", HIAPI_RSL_NAME);
	return false;
}
/*****************************************************************************
* FUNCTION:     RslMain
*
* DESCRIPTION:
*  RSL Main֐
\*****************************************************************************/

BOOLEAN __stdcall RslMain(RTHANDLE hModule,
	DWORD  ul_reason_for_call,
	LPVOID lpReserved
)
{
	switch (ul_reason_for_call) {
	case RSL_PROCESS_ATTACH: //vZXA^b`Cxg
		fnLoadHiApiEntry();
		break;
	case RSL_THREAD_ATTACH:
	case RSL_THREAD_DETACH:
	case RSL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}
