//
//  RT-edge C2C(R) FLNET Wrapper
//
//   RSL development header
//
//   Copyright (c)Micronet.Co 2022
//
#ifndef _eWrapFLNET_H_
#define _eWrapFLNET_H_

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

#ifdef  eWrapFLNET_EXPORTS
#define eWrapFLNET_API
#else
#define eWrapFLNET_API __declspec(dllimport)
#endif

#include <egAPI.h>			// RT-edge system API
#include <HiFL.h>			// RSI-040 Hi level API
//
// define`
//

#define HIAPI_NO_INIT	17330	//nCxAPI INIT 
#define HIAPI_NO_OPEN	17331	//nCxAPI OPEN 
#define HIAPI_NO_CLOSE	17332	//nCxAPI CLOSE 
#define HIAPI_NO_READ	17333	//nCxAPI READ 
#define HIAPI_NO_WRITE	17334	//nCxAPI WRITE 

#define HIAPI_RSL_NAME	"HiFLNET.rsl"

#define __FILE_NAME__		(strrchr(__FILE__, '\\') ? strrchr(__FILE__, '\\')+1 : __FILE__)
#define Log$(pServiceName, pMode, MSG, ...)	fnLog(pServiceName, pMode, MSG",%s,%05d", __VA_ARGS__, __FILE_NAME__, __LINE__)
#define WARN(reason)	WarningMsg(__LINE__,(reason))

// R[obN֐̖߂l`
#define CB_STS_OK			EDGE_SUCCESS	// 
#define CB_STS_ERROR		0x00000001			// \G[
#define CB_STS_UNRECOVERY	0x00000010			// s\G[
#define CB_STS_FATALERR		0x00000100			// vIG[
#define EW_NOAPI			0xFFFFFFFF		// ֐

eWrapFLNET_API DWORD HiInit(char* szIFName, IFHANDLE* hIF, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapFLNET_API DWORD HiOpen(IFHANDLE hIF, RSIHANDLE* hRsi, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapFLNET_API DWORD HiClose(RSIHANDLE hRsi, DWORD* dwAPIStatus);
eWrapFLNET_API DWORD HiRead(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD readsize, BYTE *pData, DWORD buffersize, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapFLNET_API DWORD HiWrite(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD writesize, BYTE *pData, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapFLNET_API DWORD HiReConnect(void* ptr, DWORD dwTimeout, DWORD* dwAPIStatus);
eWrapFLNET_API BOOL HiConnectChk(void* ptr, DWORD dwTimeout, DWORD* dwErrorStatus);
#ifdef __cplusplus
}
#endif // __cplusplus

#endif
