﻿// libfinstest.cpp : このファイルには 'main' 関数が含まれています。プログラム実行の開始と終了がそこで行われます。
//

#include <iostream>
#include "fins.h"

#include <winsock2.h>

#define MAXERR		255

int main()
{
    std::cout << "Hello World!\n";

	// winsock initialize
	WORD version = MAKEWORD(2, 2);
	WSADATA wsa;
	WSAStartup(version, &wsa);

	// connect
	fins_sys_tp	*sys;
	char		RAddress[] = "192.168.250.1";
	uint16_t	port = FINS_DEFAULT_PORT;
	uint8_t		LNet = 0;
	uint8_t		LNode = 0x00;
	uint8_t		LUnit = 0;
	uint8_t		RNet = 0;
	uint8_t		RNode = 0x01;
	uint8_t		RUnit = 0;
	int			errmax = MAXERR;
	int			errval[MAXERR];
	sys = finslib_tcp_connect(NULL, RAddress, port, LNet, LNode, LUnit, RNet, RNode, RUnit, errval, errmax);

	//
	struct fins_cpudata_tp cpudata;
	auto result3 = finslib_cpu_unit_data_read(sys, &cpudata);

	uint16_t		wordbuf[4] = { 0 };
	bool			boolbuf[4];
	int				result;
	result = finslib_memory_area_read_uint16(sys, "A264", wordbuf, 1);			// A264 is P_Cycle_Time_Value, UDINT サイクルタイム現在値
	result = finslib_memory_area_read_uint16(sys, "A262", wordbuf, 1);			// A262 is P_Max_Cycle_Time, UDINT サイクルタイム最大値
	result = finslib_memory_area_read_uint16(sys, "A450", wordbuf, 1);			// A250 is P_CIO, WORD CIOエリア指定 = must 0x00B0

	wordbuf[0] = 0xcccc;
	result = finslib_memory_area_read_uint16(sys, "CIO001", wordbuf, 1);		// 0000 - 6143 チャンネルIO(CIO)
	wordbuf[0] = 0x4321;
	wordbuf[1] = 0xedcb;
	result = finslib_memory_area_write_uint16(sys, "CIO001", wordbuf, 2);		// 0000 - 6143 チャンネルIO(CIO)
	result = finslib_memory_area_write_uint16(sys, "W001", wordbuf, 2);			// W000 - W511 内部補助リレー
	boolbuf[0] = false;
	result = finslib_memory_area_write_bit(sys, "W001.0", boolbuf, 1);			// W000.00 - W511.15 内部補助リレー ビットアドレス
	result = finslib_memory_area_write_bit(sys, "W001.15", boolbuf, 1);			// W000.00 - W511.15 内部補助リレー ビットアドレス
	boolbuf[0] = true;
	result = finslib_memory_area_write_bit(sys, "W001.00", boolbuf, 1);			// W000.00 - W511.15 内部補助リレー ビットアドレス

	result = finslib_memory_area_read_bit(sys, "CF105", boolbuf, 1);			// CCF105 is P_0_01s [no readable]
	result = finslib_memory_area_read_bit(sys, "CF102", boolbuf, 1);			// CCF105 is P_1s [no readable]
	result = finslib_memory_area_read_bit(sys, "A402.4", boolbuf, 1);			// A402.4 is P_Low_Bat

	//
	finslib_disconnect(sys);
}

